【codeforces 370C】Mittens

【题目链接】:http://codeforces.com/problemset/problem/370/C

【题意】

给你n个人,每个人都有一双相同颜色的手套;
然允许在所有人之间交换手套;
(每个人的手套有左右之分,左手套不能戴在右手上)
问你最后,每个人的左右手的手套颜色不同的人数最多能有多少个;

【题解】

贪心;
把手套的颜色,按照数量降序排;
然后顺序枚举;
一种颜色一种颜色的枚举;
假设i..j是一种颜色;
则在1..i-1中找手套和它换;
优先找左右手的手套一样的人的;
因为这样换了之后,不同的人数+2
如果实在找不到相同的;
就找左右手套不同的人换就好;
这样,不同的人数+1;
这样的贪心策略显然是对的吧;

【Number Of WA

0

【完整代码】

#include <bits/stdc++.h>
using namespace std;
#define lson l,m,rt<<1
#define rson m+1,r,rt<<1|1
#define LL long long
#define rep1(i,a,b) for (int i = a;i <= b;i++)
#define rep2(i,a,b) for (int i = a;i >= b;i--)
#define mp make_pair
#define pb push_back
#define fi first
#define se second
#define ms(x,y) memset(x,y,sizeof x)
#define Open() freopen("F:\rush.txt","r",stdin)
#define Close() ios::sync_with_stdio(0)

typedef pair<int,int> pii;
typedef pair<LL,LL> pll;

const int dx[9] = {0,1,-1,0,0,-1,-1,1,1};
const int dy[9] = {0,0,0,-1,1,-1,1,-1,1};
const double pi = acos(-1.0);
const int M = 110;
const int N = 5e3+100;

struct abc{
    int idx,num;
};

int n,m,c[N][3],d[N][2];
vector <int> a[M];
abc b[N];

int main(){
   // Open();
    Close();
    cin >> n >> m;
    rep1(i,1,n){
        int x;
        cin >> x;
        a[x].pb(i);
    }
    n = 0;
    rep1(i,1,m)
    if (!a[i].empty()){
        b[++n].idx = i;
        b[n].num = (int) a[i].size();
    }
    sort(b+1,b+1+n,[&] ( abc a,abc b) { return a.num > b.num;});
    int nn = 0;
    rep1(i,1,n){
        int id = b[i].idx;
        while ( (int) a[id].size()){
            nn++;
            c[nn][0] = c[nn][1] = id;
            c[nn][2] = a[id].back();
            a[id].pop_back();
        }
    }
    n = nn;
    rep1(i,1,n){
        int j = i;
        while (j+1<=n && c[j+1][0]==c[j][0]) j++;
        //cout << i <<' '<< j << endl;
        int now = i;
        rep1(k,1,i-1)
        if (c[k][0]==c[k][1] && c[k][0] != c[now][0]){
            if (now > j ) break;
            swap(c[k][0],c[now][0]);
            now++;
        }
        rep1(k,1,i-1)
        if (c[k][0] != c[now][0]){
            if (now > j ) break;
            swap(c[k][0],c[now][0]);
            now++;
        }
        i = j;
    }
    int ans = 0;
    rep1(i,1,n)
        if (c[i][0]!=c[i][1]) ans++;
    rep1(i,1,n){
        d[c[i][2]][0] = c[i][0];
        d[c[i][2]][1] = c[i][1];
    }
    cout << ans << endl;
    rep1(i,1,n){
        cout << d[i][0] <<' ' << d[i][1] << endl;
    }
    return 0;
}
原文地址:https://www.cnblogs.com/AWCXV/p/7626248.html